/**
 * Yum Food Orders
 * **Yum application, order food daily from the best chef in town**  This API is used by the angular.io client, and is not meant to be used otherwise.  Find source code of this API [here](http://gitlab/)  Copyright (C) 2017 JR Technologies.
 *
 * OpenAPI spec version: 1.1.0
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class HungryApi {
    protected basePath = 'http://localhost:8082/api';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    private convertDates(res: Response) {
      var data = res.json() || [];
      data.forEach((d) => {
        d.date = new Date(d.date);
      });
      return data;
    }

    // convert the date send to the server because server uses LocalDate variable while javascript uses Date which corresponds to LocalDateTime
    private convertOrderSave(body: models.OrderSave): string{
      const convertedBody = {
        dailyMenuId : body.dailyMenuId,
        dailyMenuVersion : body.dailyMenuVersion,
        date : body.date.getFullYear() + '-' + (body.date.getMonth() + 1) + '-' + body.date.getDate(),
        orderItems : body.orderItems,
        orderVersion : body.orderVersion
      }

      return JSON.stringify(convertedBody);
    }

    /**
     * Returns a list containing all daily orders of the month
     * The monthly menu fetches all daily orders of the current month.
     */
    public menusMonthlyGet(extraHttpRequestParams?: any): Observable<models.Orders> {
        return this.menusMonthlyGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return this.convertDates(response);
                }
            });
    }

    /**
     * returns a list containing all daily orders of the given month
     * returns a list containing all daily orders of the given month
     * @param month
     * @param year
     */
    public menusMonthlyYearMonthGet(month: number, year: number, extraHttpRequestParams?: any): Observable<models.Orders> {
        return this.menusMonthlyYearMonthGetWithHttpInfo(month, year, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return this.convertDates(response);
                }
            });
    }

    /**
     * Returns a list containing all 5 daily Menus of this week
     * The weekly menu fetches the five daily menus of the current week. Each daily menu contains the list of foods offered for that day along with the price it costs. Also the daily menus contains any ordering information for the specific user who made the request.
     */
    public menusWeeklyGet(extraHttpRequestParams?: any): Observable<models.DailyMenus> {
        return this.menusWeeklyGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return this.convertDates(response);
                }
            });
    }

    /**
     * Returns a list containing all 5 daily Menus of the given week
     * The weekly menu fetches the five daily menus of a given week. Each daily menu contains the list of foods offered for that day along with the price it costs. Also the daily menus contains any ordering information for the specific user who made the request
     * @param week
     * @param year
     */
    public menusWeeklyYearWeekGet(week: number, year: number, extraHttpRequestParams?: any): Observable<models.DailyMenus> {
        return this.menusWeeklyYearWeekGetWithHttpInfo(week, year, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return this.convertDates(response);
                }
            });
    }

    /**
     * deletes order if it is not final
     * deletes order if it is not final
     * @param id
     * @param menuId
     * @param date
     * @param menuVersion
     */
    public ordersIdDelete(id: number, menuId: number, date: string, menuVersion: number, extraHttpRequestParams?: any): Observable<{}> {
        return this.ordersIdDeleteWithHttpInfo(id, menuId, date, menuVersion, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else if (response.status === 410 || response.status === 409) {
                    return this.convertDates(response);
                } else {
                    return response.json();
                }
            });
    }

    /**
     * gets the order by id
     * gets the order by id
     * @param id
     * @param menuId
     * @param date
     * @param menuVersion
     */
    public ordersIdGet(id: number, menuId: number, date: string, menuVersion: number, extraHttpRequestParams?: any): Observable<models.DailyMenu> {
        return this.ordersIdGetWithHttpInfo(id, menuId, date, menuVersion, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * updates order found by its id
     * updates order found by its id
     * @param id
     * @param body
     * @param email
     */
    public ordersIdPut(id: number, body: models.OrderSave, email?: boolean, extraHttpRequestParams?: any): Observable<models.NewEntry> {
        return this.ordersIdPutWithHttpInfo(id, body, email, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else if (response.status === 410 || response.status === 409) {
                    return this.convertDates(response);
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Places order in specific day
     * Creates a dailyOrder with new orderItems
     * @param body
     * @param email
     */
    public ordersPost(body: models.OrderSave, email?: boolean, extraHttpRequestParams?: any): Observable<models.NewEntry> {
        return this.ordersPostWithHttpInfo(body, email, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else if (response.status === 410 || response.status === 409) {
                    return this.convertDates(response);
                } else {
                    return response.json();
                }
            });
    }

    /**
     * returns the current user&#39;s details
     * returns the current user&#39;s details
     */
    public settingsGet(extraHttpRequestParams?: any): Observable<models.UserGet> {
        return this.settingsGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * user deletes his/her picture
     * user deletes his/her picture
     */
    public settingsPictureDelete(extraHttpRequestParams?: any): Observable<{}> {
        return this.settingsPictureDeleteWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * user uploads his/her picture
     * user clicks the \&quot;upload picture\&quot; button and chooses his/her picture in the dialog. The API uploads the picture and sends it to the server
     * @param upfile The file to upload.
     */
    public settingsPicturePost(file?: any, extraHttpRequestParams?: any): Observable<{}> {
        return this.settingsPicturePostWithHttpInfo(file, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * user gets his picture
     * user gets his picture
     * @param token
     */
    public settingsPictureTokenGet(token: string, extraHttpRequestParams?: any): Observable<any> {
        return this.settingsPictureTokenGetWithHttpInfo(token, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * change profile data
     * change profile data
     * @param body
     */
    public settingsPut(body: models.UserSave, extraHttpRequestParams?: any): Observable<{}> {
        return this.settingsPutWithHttpInfo(body, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }




    /**
     * Returns a list containing all daily orders of the month
     * The monthly menu fetches all daily orders of the current month.
     */
    public menusMonthlyGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/menus/monthly`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * returns a list containing all daily orders of the given month
     * returns a list containing all daily orders of the given month
     * @param month
     * @param year
     */
    public menusMonthlyYearMonthGetWithHttpInfo(month: number, year: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/menus/monthly/${year}/${month}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'month' is not null or undefined
        if (month === null || month === undefined) {
            throw new Error('Required parameter month was null or undefined when calling menusMonthlyYearMonthGet.');
        }
        // verify required parameter 'year' is not null or undefined
        if (year === null || year === undefined) {
            throw new Error('Required parameter year was null or undefined when calling menusMonthlyYearMonthGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Returns a list containing all 5 daily Menus of this week
     * The weekly menu fetches the five daily menus of the current week. Each daily menu contains the list of foods offered for that day along with the price it costs. Also the daily menus contains any ordering information for the specific user who made the request.
     */
    public menusWeeklyGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/menus/weekly`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Returns a list containing all 5 daily Menus of the given week
     * The weekly menu fetches the five daily menus of a given week. Each daily menu contains the list of foods offered for that day along with the price it costs. Also the daily menus contains any ordering information for the specific user who made the request
     * @param week
     * @param year
     */
    public menusWeeklyYearWeekGetWithHttpInfo(week: number, year: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/menus/weekly/${year}/${week}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'week' is not null or undefined
        if (week === null || week === undefined) {
            throw new Error('Required parameter week was null or undefined when calling menusWeeklyYearWeekGet.');
        }
        // verify required parameter 'year' is not null or undefined
        if (year === null || year === undefined) {
            throw new Error('Required parameter year was null or undefined when calling menusWeeklyYearWeekGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * deletes order if it is not final
     * deletes order if it is not final
     * @param id
     * @param menuId
     * @param date
     * @param menuVersion
     */
    public ordersIdDeleteWithHttpInfo(id: number, menuId: number, date: string, menuVersion: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/orders/${id}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling ordersIdDelete.');
        }
        // verify required parameter 'menuId' is not null or undefined
        if (menuId === null || menuId === undefined) {
            throw new Error('Required parameter menuId was null or undefined when calling ordersIdDelete.');
        }
        // verify required parameter 'date' is not null or undefined
        if (date === null || date === undefined) {
            throw new Error('Required parameter date was null or undefined when calling ordersIdDelete.');
        }
        // verify required parameter 'menuVersion' is not null or undefined
        if (menuVersion === null || menuVersion === undefined) {
            throw new Error('Required parameter menuVersion was null or undefined when calling ordersIdDelete.');
        }
        if (menuId !== undefined) {
            queryParameters.set('menuId', <any>menuId);
        }

        if (date !== undefined) {
            queryParameters.set('date', <any>date);
        }

        if (menuVersion !== undefined) {
            queryParameters.set('menuVersion', <any>menuVersion);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * gets the order by id
     * gets the order by id
     * @param id
     * @param menuId
     * @param date
     * @param menuVersion
     */
    public ordersIdGetWithHttpInfo(id: number, menuId: number, date: string, menuVersion: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/orders/${id}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling ordersIdGet.');
        }
        // verify required parameter 'menuId' is not null or undefined
        if (menuId === null || menuId === undefined) {
            throw new Error('Required parameter menuId was null or undefined when calling ordersIdGet.');
        }
        // verify required parameter 'date' is not null or undefined
        if (date === null || date === undefined) {
            throw new Error('Required parameter date was null or undefined when calling ordersIdGet.');
        }
        // verify required parameter 'menuVersion' is not null or undefined
        if (menuVersion === null || menuVersion === undefined) {
            throw new Error('Required parameter menuVersion was null or undefined when calling ordersIdGet.');
        }
        if (menuId !== undefined) {
            queryParameters.set('menuId', <any>menuId);
        }

        if (date !== undefined) {
            queryParameters.set('date', <any>date);
        }

        if (menuVersion !== undefined) {
            queryParameters.set('menuVersion', <any>menuVersion);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * updates order found by its id
     * updates order found by its id
     * @param id
     * @param body
     * @param email
     */
    public ordersIdPutWithHttpInfo(id: number, body: models.OrderSave, email?: boolean, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/orders/${id}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling ordersIdPut.');
        }
        // verify required parameter 'body' is not null or undefined
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling ordersIdPut.');
        }
        if (email !== undefined) {
            queryParameters.set('email', <any>email);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: body == null ? '' : this.convertOrderSave(body), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        console.log(requestOptions.body);

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Places order in specific day
     * Creates a dailyOrder with new orderItems
     * @param body
     * @param email
     */
    public ordersPostWithHttpInfo(body: models.OrderSave, email?: boolean, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/orders`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'body' is not null or undefined
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling ordersPost.');
        }
        if (email !== undefined) {
            queryParameters.set('email', <any>email);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: body == null ? '' : this.convertOrderSave(body), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * returns the current user&#39;s details
     * returns the current user&#39;s details
     */
    public settingsGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/settings`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * user deletes his/her picture
     * user deletes his/her picture
     */
    public settingsPictureDeleteWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/settings/picture`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * user uploads his/her picture
     * user clicks the \&quot;upload picture\&quot; button and chooses his/her picture in the dialog. The API uploads the picture and sends it to the server
     * @param upfile The file to upload.
     */
    public settingsPicturePostWithHttpInfo(file?: any, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/settings/picture`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        let formParams = new URLSearchParams();

        // to determine the Content-Type header
        let consumes: string[] = [
            'multipart/form-data'
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        headers.set('Content-Type', 'application/x-www-form-urlencoded');

        if (file !== undefined) {
            formParams.set('upfile', <any>file);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: formParams.toString(),
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * user gets his picture
     * user gets his picture
     * @param token
     */
    public settingsPictureTokenGetWithHttpInfo(token: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/settings/picture/token`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'token' is not null or undefined
        if (token === null || token === undefined) {
            throw new Error('Required parameter token was null or undefined when calling settingsPictureTokenGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'image/jpeg'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * change profile data
     * change profile data
     * @param body
     */
    public settingsPutWithHttpInfo(body: models.UserSave, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/settings`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'body' is not null or undefined
        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling settingsPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: body == null ? '' : JSON.stringify(body), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }


}
